"""
Inverse Multiquadric (IMQ) Radial Basis function class

import suggestion: from iMqx import *

"""

from numpy import sqrt
from rbfClassX import rbfx

class imqx(rbfx):

	def rbf(self,r,s):
		return 1.0/sqrt(1.0 + (r*s)**2)

	def D1(self, r, s, x):
		return -s**2*x/(r**2*s**2 + 1)**(1.5)

	def D2(self, r, s, x):
		return s**2*(-r**2*s**2 + 3*s**2*x**2 - 1)/(r**2*s**2 + 1)**(2.5)
		
	def D3(self, r, s, x):
		return 3*s**4*x*(3*r**2*s**2 - 5*s**2*x**2 + 3)/(r**2*s**2 + 1)**(3.5)

	def D4(self, r, s, x):
		return 3*s**4*(35*s**4*x**4 - 30*s**2*x**2*(r**2*s**2 + 1) + 3*(r**2*s**2 + 1)**2)/(r**2*s**2 + 1)**(4.5)

	def div(self, r, s, x, y=0, z=0): 
		return -s**2*(x + y + z)/(r**2*s**2 + 1)**(1.5)

	def L(self, r, s):      
		return s**2*(-2*r**2*s**2 + 3*s**2*r**2 - 2)/(r**2*s**2 + 1)**(5/2)

	def B(self, r, s, x, y):     
		return 3*s**4*(-10*r**2*s**2*(r**2*s**2 + 1) + 35*s**4*x**4 + 70*s**4*x**2*y**2 + 35*s**4*y**4 - 30*s**2*x**2*(r**2*s**2 + 1) - 30*s**2*y**2*(r**2*s**2 + 1) + 8*(r**2*s**2 + 1)**2)/(r**2*s**2 + 1)**(4.5)
		
	def D12(self,r,s,x,y):
		return 3*s**4*x*(r**2*s**2 - 5*s**2*y**2 + 1)/(r**2*s**2 + 1)**(3.5)

	def D22(self,r,s,x,y):
		return 3*s**4*(-5*r**2*s**2*(r**2*s**2 + 1) + 35*s**4*x**2*y**2 + (r**2*s**2 + 1)**2)/(r**2*s**2 + 1)**(4.5)

	def hyperViscosity(self,dim,order,shape,r): return 0