"""
Inverse Quadratic (IQ) Radial Basis function class

import suggestion: from iqx import *

"""


from rbfClassX import rbfx

class iqx(rbfx):

	def rbf(self,r,s):
		return 1.0/(1.0 + (r*s)**2)

	def D1(self, r, s, x):
		return -(2*x*(s**2))/(1.0 + (r*s)**2)**2

	def D2(self, r, s, x):
		return (8*x**2*s**4)/(1.0 + (r*s)**2)**3 - (2*s**2)/(1.0 + (r*s)**2)**2
		
	def D3(self, r, s, x):
		return (-48*x**3*s**6)/(r**2*s**2 + 1)**4 + (24*x*s**4)/(r**2*s**2 + 1)**3

	def D4(self, r, s, x):
		return (384*x**4*s**8)/(r**2*s**2 + 1)**5 - (288*x**2*s**6)/(r**2*s**2 + 1)**4 + (24*s**4)/(r**2*s**2 + 1)**3
	
	def div(self, r, s, x, y=0, z=0): return -2*s**2*(x + y + z)/(r**2*s**2 + 1)**2   # divergence

	def L(self, r, s):      # Laplacian
		return ( 4*s**2*( r**2*s**2 - 1 ) )/(1.0 + (r*s)**2)**3

	def B(self, r, s, x, y):      # Biharmonic operator
		return ( 64*( s**4 - 4*s**6*r**2 + s**8*r**4 ) )/(1.0 + (r*s)**2)**5
		
	def D12(self,r,s,x,y):
		return 8*x*s**4*(1 - 5*y**2*s**2 + x**2*s**2  )/(1 + (s*r)**2 )**4

	def D22(self,r,s,x,y):
		return -8*s**4*(-1 + 4*r**2*s**2 + 5*(x**4 + y**4)*s**4 - 38*x**2*y**2*s**4  )/(1 + (s*r)**2 )**5
	
	def hyperViscosity(self,dim,order,shape,r): return 0
	
	
		


