"""
Visualizes a local RBF stencil and a RBF PU patch.

usage: run localMethodImages.py

"""

import matplotlib.pyplot as plt
import rbfCentersLib as cl
import rbfLocal as LR
import rbfPU as PU

plt.close('all')

x, y, bpi = cl.rbfCentersLib(4)
X = list( zip(x,y) )

# ---------------------- Local methood --------------------------------

ns = 30                      # local stencil size
st = LR.stencils(X,ns)  
   

plt.scatter(x,y,c='b',marker='.')

centerNumber = 400
plt.scatter(x[st[centerNumber]],y[st[centerNumber]],c='k',marker='+')
plt.scatter(x[centerNumber],y[centerNumber],c='r',marker='*')


centerNumber = 1
plt.scatter(x[st[centerNumber]],y[st[centerNumber]],c='k',marker='+')
plt.scatter(x[centerNumber],y[centerNumber],c='r',marker='*')
plt.xlabel('x'), plt.ylabel('y')

plt.show()

# ---------------------- partion of unity ------------------------------

plt.figure()

numCirclesXandY = 5
radius, x0, y0, cov = PU.cover2d(x,y,numCirclesXandY,fac=0.75,threshold=8)

PU.plotCover(x,y,x0,y0,radius)
plt.xlabel('x'), plt.ylabel('y')

plt.show()





