# import rbfCenterTools as ct

import scipy as sp
from numpy import outer, sqrt, amin, nonzero, delete, ones
import matplotlib.pyplot as pplt

def deleteCloseCenters(x1,y1,x2,y2,tol,plt=False):
	""" delete centers from (x1,y1) which are less than a distance tol from
		any center in (x2,y2)
	"""
	s1, s2 = len(x1), len(x2)
	rx = outer(x1,sp.ones((1,s2))) - outer( ones((s1,1)),x2.T)
	ry = outer(y1,ones((1,s2))) - outer( ones((s1,1)),y2.T)
	d = sqrt(rx**2 + ry**2)
	md = amin(d, axis=1)          
	ind = nonzero(md<tol)
	x1 = delete(x1,ind[0])
	y1 = delete(y1,ind[0])
	
	if plt: pplt.scatter(x1,y1,c='b',marker='.')
	
	return x1, y1
	


